package dev.shadowsoffire.apotheosis.village;

import org.apache.logging.log4j.LogManager;
import net.minecraftforge.network.PlayMessages;
import dev.shadowsoffire.placebo.menu.MenuUtil;
import dev.shadowsoffire.apotheosis.village.fletching.FletchingContainer;
import net.minecraft.world.inventory.MenuType;
import dev.shadowsoffire.apotheosis.village.fletching.arrows.ExplosiveArrowEntity;
import dev.shadowsoffire.apotheosis.village.fletching.arrows.BroadheadArrowEntity;
import net.minecraft.world.entity.MobCategory;
import dev.shadowsoffire.apotheosis.village.fletching.arrows.ObsidianArrowEntity;
import net.minecraft.world.entity.EntityType;
import dev.shadowsoffire.placebo.tabs.TabFillingRegistry;
import dev.shadowsoffire.apotheosis.Apoth;
import java.util.function.Supplier;
import net.minecraft.world.item.CreativeModeTabs;
import dev.shadowsoffire.apotheosis.village.fletching.arrows.MiningArrowItem;
import dev.shadowsoffire.apotheosis.village.fletching.arrows.MiningArrowEntity;
import net.minecraft.world.item.Items;
import dev.shadowsoffire.apotheosis.village.fletching.arrows.ExplosiveArrowItem;
import dev.shadowsoffire.apotheosis.village.fletching.arrows.BroadheadArrowItem;
import dev.shadowsoffire.apotheosis.village.fletching.arrows.ObsidianArrowItem;
import dev.shadowsoffire.placebo.util.PlaceboUtil;
import dev.shadowsoffire.apotheosis.village.fletching.ApothFletchingBlock;
import net.minecraft.world.level.block.Blocks;
import net.minecraft.world.level.block.Block;
import dev.shadowsoffire.placebo.registry.RegistryEvent;
import net.minecraftforge.fml.event.lifecycle.FMLClientSetupEvent;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import java.util.Iterator;
import net.minecraft.core.dispenser.DispenseItemBehavior;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.level.block.DispenserBlock;
import net.minecraft.world.entity.projectile.Projectile;
import net.minecraft.world.item.ItemStack;
import net.minecraft.core.Position;
import net.minecraft.core.dispenser.AbstractProjectileDispenseBehavior;
import dev.shadowsoffire.apotheosis.village.fletching.arrows.IApothArrowItem;
import net.minecraft.world.item.Item;
import net.minecraftforge.registries.ForgeRegistries;
import dev.shadowsoffire.apotheosis.village.wanderer.WandererReplacements;
import java.io.File;
import dev.shadowsoffire.apotheosis.Apotheosis;
import net.minecraftforge.fml.event.lifecycle.FMLCommonSetupEvent;
import net.minecraft.world.level.Level;
import dev.shadowsoffire.placebo.config.Configuration;
import org.apache.logging.log4j.Logger;
import dev.shadowsoffire.apotheosis.village.fletching.FletchingRecipe;
import net.minecraft.world.item.crafting.RecipeSerializer;

public class VillageModule
{
    public static final RecipeSerializer<FletchingRecipe> FLETCHING_SERIALIZER;
    public static final Logger LOGGER;
    public static Configuration config;
    public static Level.ExplosionInteraction expArrowMode;
    
    @SubscribeEvent
    public void setup(final FMLCommonSetupEvent e) {
        (VillageModule.config = new Configuration(new File(Apotheosis.configDir, "village.cfg"))).setTitle("Apotheosis Village Module Configuration");
        WandererReplacements.load(VillageModule.config);
        final boolean blockDmg = VillageModule.config.getBoolean("Explosive Arrow Block Damage", "arrows", true, "If explosive arrows can break blocks.\nServer-authoritative.");
        VillageModule.expArrowMode = (blockDmg ? Level.ExplosionInteraction.BLOCK : Level.ExplosionInteraction.NONE);
        if (VillageModule.config.hasChanged()) {
            VillageModule.config.save();
        }
        e.enqueueWork(() -> {
            ForgeRegistries.ITEMS.iterator();
            final Iterator iterator;
            while (iterator.hasNext()) {
                final Item i = iterator.next();
                if (i instanceof IApothArrowItem) {
                    DispenserBlock.m_52672_((ItemLike)i, (DispenseItemBehavior)new AbstractProjectileDispenseBehavior() {
                        final /* synthetic */ Item val$i;
                        
                        protected Projectile m_6895_(final Level world, final Position pos, final ItemStack stack) {
                            return (Projectile)((IApothArrowItem)this.val$i).fromDispenser(world, pos.m_7096_(), pos.m_7098_(), pos.m_7094_());
                        }
                    });
                }
            }
        });
    }
    
    @SubscribeEvent
    public void setup(final FMLClientSetupEvent e) {
        e.enqueueWork(VillageModuleClient::init);
    }
    
    @SubscribeEvent
    public void serializers(final RegistryEvent.Register<RecipeSerializer<?>> e) {
        e.getRegistry().register((Object)VillageModule.FLETCHING_SERIALIZER, FletchingRecipe.Serializer.NAME);
    }
    
    @SubscribeEvent
    public void blocks(final RegistryEvent.Register<Block> e) {
        PlaceboUtil.registerOverride(Blocks.f_50622_, (Block)new ApothFletchingBlock(), "apotheosis");
    }
    
    @SubscribeEvent
    public void items(final RegistryEvent.Register<Item> e) {
        e.getRegistry().registerAll(new Object[] { new ObsidianArrowItem(new Item.Properties()), "obsidian_arrow", new BroadheadArrowItem(new Item.Properties()), "broadhead_arrow", new ExplosiveArrowItem(new Item.Properties()), "explosive_arrow", new MiningArrowItem(() -> Items.f_42385_, MiningArrowEntity.Type.IRON), "iron_mining_arrow", new MiningArrowItem(() -> Items.f_42390_, MiningArrowEntity.Type.DIAMOND), "diamond_mining_arrow" });
        TabFillingRegistry.register(CreativeModeTabs.f_256797_, new Supplier[] { (Supplier)Apoth.Items.OBSIDIAN_ARROW, (Supplier)Apoth.Items.BROADHEAD_ARROW, (Supplier)Apoth.Items.EXPLOSIVE_ARROW, (Supplier)Apoth.Items.IRON_MINING_ARROW, (Supplier)Apoth.Items.DIAMOND_MINING_ARROW });
    }
    
    @SubscribeEvent
    public void entities(final RegistryEvent.Register<EntityType<?>> e) {
        e.getRegistry().register((Object)EntityType.Builder.m_20704_(ObsidianArrowEntity::new, MobCategory.MISC).setShouldReceiveVelocityUpdates(true).setTrackingRange(4).setUpdateInterval(20).m_20699_(0.5f, 0.5f).setCustomClientFactory((se, w) -> new ObsidianArrowEntity(w)).m_20712_("obsidian_arrow"), "obsidian_arrow");
        e.getRegistry().register((Object)EntityType.Builder.m_20704_(BroadheadArrowEntity::new, MobCategory.MISC).setShouldReceiveVelocityUpdates(true).setTrackingRange(4).setUpdateInterval(20).m_20699_(0.5f, 0.5f).setCustomClientFactory((se, w) -> new BroadheadArrowEntity(w)).m_20712_("broadhead_arrow"), "broadhead_arrow");
        e.getRegistry().register((Object)EntityType.Builder.m_20704_(ExplosiveArrowEntity::new, MobCategory.MISC).setShouldReceiveVelocityUpdates(true).setTrackingRange(4).setUpdateInterval(20).m_20699_(0.5f, 0.5f).setCustomClientFactory((se, w) -> new ExplosiveArrowEntity(w)).m_20712_("explosive_arrow"), "explosive_arrow");
        e.getRegistry().register((Object)EntityType.Builder.m_20704_(MiningArrowEntity::new, MobCategory.MISC).setShouldReceiveVelocityUpdates(true).setTrackingRange(4).setUpdateInterval(20).m_20699_(0.5f, 0.5f).setCustomClientFactory((se, w) -> new MiningArrowEntity(w)).m_20712_("mining_arrow"), "mining_arrow");
    }
    
    @SubscribeEvent
    public void containers(final RegistryEvent.Register<MenuType<?>> e) {
        e.getRegistry().register((Object)MenuUtil.type(FletchingContainer::new), "fletching");
    }
    
    static {
        FLETCHING_SERIALIZER = (RecipeSerializer)new FletchingRecipe.Serializer();
        LOGGER = LogManager.getLogger("Apotheosis : Village");
        VillageModule.expArrowMode = Level.ExplosionInteraction.BLOCK;
    }
}
